variables:
  IMAGE_TAG_VERSION: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  IMAGE_TAG_LATEST: $CI_REGISTRY_IMAGE:latest
  IMAGE_TAG_TEST: $CI_REGISTRY_IMAGE:test
  # Tell 'docker:dind' to enable TLS (recommended)
  # and generate certificates in the specified directory.
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_DRIVER: overlay2

build-push-docker-image-version:
  stage: build
  # Specify a Docker image to run the job in.
  image: docker:latest
  # Specify an additional image 'docker:dind' ("Docker-in-Docker") that
  # will start up the Docker daemon when it is brought up by a runner.
  services:
    - docker:20.10.23-dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG_VERSION .
    - docker push $IMAGE_TAG_VERSION
  only:
    refs:
      - tags

build-push-docker-image-latest:
  stage: build
  # Specify a Docker image to run the job in.
  image: docker:latest
  # Specify an additional image 'docker:dind' ("Docker-in-Docker") that
  # will start up the Docker daemon when it is brought up by a runner.
  services:
    - docker:20.10.23-dind
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG_LATEST .
    - docker push $IMAGE_TAG_LATEST
  only:
    refs:
      - master

deploy:
  stage: deploy
  image: alpine
  before_script:
    - apk add openssh-client
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - ssh-keyscan -t rsa ssh.manson.io >> ~/.ssh/known_hosts 
  script:
    - ssh deploy@ssh.manson.io docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY
    - ssh deploy@ssh.manson.io "cd /home/luke/wedding/ && docker-compose pull && docker-compose up -d"
  only:
    refs:
      - master
